<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (172)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="sticky-flag-y-searching-at-position">
      Sticky flag “y”, searching at position
    </h1>
    <p>
      The flag <code>pattern:y</code> allows to perform the search at the given
      position in the source string.
    </p>
    <p>
      To grasp the use case of <code>pattern:y</code> flag, and better
      understand the ways of regexps, let’s explore a practical example.
    </p>
    <p>
      One of common tasks for regexps is “lexical analysis”: we get a text,
      e.g. in a programming language, and need to find its structural elements.
      For instance, HTML has tags and attributes, JavaScript code has functions,
      variables, and so on.
    </p>
    <p>
      Writing lexical analyzers is a special area, with its own tools and
      algorithms, so we don’t go deep in there, but there’s a common task: to
      read something at the given position.
    </p>
    <p>
      E.g. we have a code string <code>subject:let varName = "value"</code>, and
      we need to read the variable name from it, that starts at position
      <code>4</code>.
    </p>
    <p>
      We’ll look for variable name using regexp <code>pattern:\w+</code>.
      Actually, JavaScript variable names need a bit more complex regexp for
      accurate matching, but here it doesn’t matter.
    </p>
    <ul>
      <li>
        A call to <code>str.match(/\w+/)</code> will find only the first word in
        the line (<code>let</code>). That’s not it.
      </li>
      <li>
        We can add the flag <code>pattern:g</code>. But then the call
        <code>str.match(/\w+/g)</code> will look for all words in the text,
        while we need one word at position <code>4</code>. Again, not what we
        need.
      </li>
    </ul>
    <p>
      <strong
        >So, how to search for a regexp exactly at the given position?</strong
      >
    </p>
    <p>Let’s try using method <code>regexp.exec(str)</code>.</p>
    <p>
      For a <code>regexp</code> without flags <code>pattern:g</code> and
      <code>pattern:y</code>, this method looks only for the first match, it
      works exactly like <code>str.match(regexp)</code>.
    </p>
    <p>
      …But if there’s flag <code>pattern:g</code>, then it performs the search
      in <code>str</code>, starting from position stored in the
      <code>regexp.lastIndex</code> property. And, if it finds a match, then
      sets <code>regexp.lastIndex</code> to the index immediately after the
      match.
    </p>
    <p>
      In other words, <code>regexp.lastIndex</code> serves as a starting point
      for the search, that each <code>regexp.exec(str)</code> call resets to the
      new value (“after the last match”). That’s only if there’s
      <code>pattern:g</code> flag, of course.
    </p>
    <p>
      So, successive calls to <code>regexp.exec(str)</code> return matches one
      after another.
    </p>
    <p>Here’s an example of such calls:</p>
    <p>
      ```js run let str = “let varName”; // Let’s find all words in this string
      let regexp = /+/g;
    </p>
    <p>alert(regexp.lastIndex); // 0 (initially lastIndex=0)</p>
    <p>
      let word1 = regexp.exec(str); alert(word1[0]); // let (1st word)
      alert(regexp.lastIndex); // 3 (position after the match)
    </p>
    <p>
      let word2 = regexp.exec(str); alert(word2[0]); // varName (2nd word)
      alert(regexp.lastIndex); // 11 (position after the match)
    </p>
    <p>
      let word3 = regexp.exec(str); alert(word3); // null (no more matches)
      alert(regexp.lastIndex); // 0 (resets at search end) ```
    </p>
    <p>We can get all matches in the loop:</p>
    <p>```js run let str = “let varName”; let regexp = /+/g;</p>
    <p>let result;</p>
    <p>
      while ((result = regexp.exec(str))) { alert(<code
        >Found ${result[0]} at position ${result.index}</code
      >); // Found let at position 0, then // Found varName at position 4 } ```
    </p>
    <p>
      Such use of <code>regexp.exec</code> is an alternative to method
      <code>str.matchAll</code>, with a bit more control over the process.
    </p>
    <p>Let’s go back to our task.</p>
    <p>
      We can manually set <code>lastIndex</code> to <code>4</code>, to start the
      search from the given position!
    </p>
    <p>Like this:</p>
    <p>```js run let str = ‘let varName = “value”’;</p>
    <p>let regexp = /+/g; // without flag “g”, property lastIndex is ignored</p>
    <p><em>!</em> regexp.lastIndex = 4; <em>/!</em></p>
    <p>let word = regexp.exec(str); alert(word); // varName ```</p>
    <p>Hooray! Problem solved!</p>
    <p>
      We performed a search of <code>pattern:\w+</code>, starting from position
      <code>regexp.lastIndex = 4</code>.
    </p>
    <p>The result is correct.</p>
    <p>…But wait, not so fast.</p>
    <p>
      Please note: the <code>regexp.exec</code> call starts searching at
      position <code>lastIndex</code> and then goes further. If there’s no word
      at position <code>lastIndex</code>, but it’s somewhere after it, then it
      will be found:
    </p>
    <p>```js run let str = ‘let varName = “value”’;</p>
    <p>let regexp = /+/g;</p>
    <p>
      <em>!</em> // start the search from position 3 regexp.lastIndex = 3;
      <em>/!</em>
    </p>
    <p>
      let word = regexp.exec(str); // found the match at position 4
      alert(word[0]); // varName alert(word.index); // 4 ```
    </p>
    <p>
      For some tasks, including the lexical analysis, that’s just wrong. We need
      to find a match exactly at the given position at the text, not somewhere
      after it. And that’s what the flag <code>y</code> is for.
    </p>
    <p>
      <strong
        >The flag <code>pattern:y</code> makes <code>regexp.exec</code> to
        search exactly at position <code>lastIndex</code>, not “starting from”
        it.</strong
      >
    </p>
    <p>Here’s the same search with flag <code>pattern:y</code>:</p>
    <p>```js run let str = ‘let varName = “value”’;</p>
    <p>let regexp = /+/y;</p>
    <p>
      regexp.lastIndex = 3; alert(regexp.exec(str)); // null (there’s a space at
      position 3, not a word)
    </p>
    <p>
      regexp.lastIndex = 4; alert(regexp.exec(str)); // varName (word at
      position 4) ```
    </p>
    <p>
      As we can see, regexp <code>pattern:/\w+/y</code> doesn’t match at
      position <code>3</code> (unlike the flag <code>pattern:g</code>), but
      matches at position <code>4</code>.
    </p>
    <p>
      Not only that’s what we need, there’s an important performance gain when
      using flag <code>pattern:y</code>.
    </p>
    <p>
      Imagine, we have a long text, and there are no matches in it, at all. Then
      a search with flag <code>pattern:g</code> will go till the end of the text
      and find nothing, and this will take significantly more time than the
      search with flag <code>pattern:y</code>, that checks only the exact
      position.
    </p>
    <p>
      In tasks like lexical analysis, there are usually many searches at an
      exact position, to check what we have there. Using flag
      <code>pattern:y</code> is the key for correct implementations and a good
      performance.
    </p>
  </body>
</html>
